	/* program to implement a deque as a link list */

#include"stdio.h"
#include"conio.h"
#include"alloc.h"

struct node
{
	int data;
	struct node *link;
};

void addqatend (struct node**,struct node**,int);
void addqateng (struct node**,struct node**,int);
delqatbeg (struct node**,struct node**);
delqatend (struct node**,struct node**);
q_discr(struct node *front);
count(struct node*front);
q_display(struct node*front);

main ()
{
	struct node *front,*rear;
	int item;

	front=rear=NULL;  /* empty queue */

	addqatend(&front,&rear,11);
	addqateng(&front,&rear,10);
	addqatend(&front,&rear,12);
	addqatend(&front,&rear,13);
	addqatend(&front,&rear,14);
	addqatend(&front,&rear,15);
	addqatend(&front,&rear,16);
	addqatend(&front,&rear,17);
	clrscr();
	q_display(front);
	printf("\nNo.ofitems in queue= %d",count(front));

	printf("\n\nltems extracted from queue:");
	item=delqatbeg(&front,&rear);
	printf(" %d",item);

	item=delqatbeg(&front,&rear);
	printf(" %d",item);

	item=delqatbeg(&front,&rear);
	printf(" %d",item);

	item=delqatend(&front,&rear);
	printf(" %d",item);

	printf("\n");
	q_display(front);
	printf("\nNo.of items in queue= %d",count(front));
	return 0;
}
	/* adds a new element at the end of queue */
void addqatend(struct node **f,struct node **r,int item)
{
	struct node *q;
	/* create new node */
	q=(struct node *)malloc(sizeof(struct node));
	q->data=item;
	q->link=NULL;
	/* if queue is empty */
	if(*f==NULL)
		*f=q;
	else
		(*r)->link=q;
	*r=q;
}
	/* adds a new element at the beginning of queue */
void addqateng(struct node **f,struct node **r,int item)
{
	struct node *q;
	int *temp;
		/* create new node */
	q=(struct node*)malloc(sizeof(struct node));
	q->data=item;
	q->link=NULL;

	/* if queue is empty */
	if(*f==NULL)
		*f=*r=q;
	else
	{
		q->link= *f;
		*r = *f;
		*f = q;
	}
}
	/* remove an element from front of queue */
delqatbeg(struct node **f,struct node **r)
{
	struct node *q;
	int item;
	/* if queue is empty */
	if(*f==NULL)
		printf("\nqueue is empty");
	else
	{       /* delete the node */
		q= *f;
		item=q->data;
		*f=q->link;
		free(q);
		/* if on deletion the queue has become empty */
		if(*f==NULL);
			*r=NULL;
		return(item);
	}
	return 0;
}
	/* remove an element from rear of queue */
delqatend(struct node **f,struct node **r)
{
	struct node *q,*rleft, *temp;
	int item;
	temp=*f;

	/* if queue is empty */
	if(*r==NULL)
		printf("\nqueue is empty");
	else
	{
	/* traverse the queue to find the previous element's address */
		while(temp!= *r)
		{
			rleft=temp;
			temp=temp->link;
		}
		 /* delete the node */
		q= *r;
		item=q->data;
		free(q);
		*r=rleft;
		(*r)->link=NULL;

		/* if on deletion the queue has become empty */
		if(*r==NULL)
			*f=NULL;
		return(item);
	}
	return 0;
}
/* displays all elements of the queue */
q_display (struct node *q)
{
	printf("\nfront->");
	/* travers the entire linked list */
	while(q!=NULL)
	{
		if(q->link==NULL)
			printf("<-rear");
		printf(" %2d",q->data);
		q=q->link;
	}
	printf("\n");
	return 0;
}
/*counts the number of nodes present in the linked list representing a queue*/
count(struct node *q)
{
	int c=0;
	/* traverse the entire linked list */
	while(q!=NULL)
	{
		q=q->link;
		c++;
	}
	return c;
}